import { Any } from 'ts-toolbelt';

type Submodule<InitArgs = {}, Config = {}, Services = {}> = Any.Compute<{
    createConfig?: (createConfigParams?: {
        initArgs: InitArgs;
    }) => Config | Promise<Config>;
    createServices?: (createServiceParams: {
        initArgs: InitArgs;
        config: Config;
    }) => Services | Promise<Services>;
}, "flat">;
type Executable<InitArgs, Config, Services, Input, Output> = (executableParam: {
    config: Config;
    services: Services;
    initArgs: InitArgs;
}, input: Input) => Output | Promise<Output>;
type ExecutableOptions<InitArgs> = {
    eager: boolean;
    initArgs: InitArgs | undefined;
};
declare const prepareExecutable: <InitArgs = {}, Config = {}, Services = {}>(submoduleDef: {
    createConfig?: ((createConfigParams?: {
        initArgs: InitArgs;
    } | undefined) => Config | Promise<Config>) | undefined;
    createServices?: ((createServiceParams: {
        initArgs: InitArgs;
        config: Config;
    }) => Services | Promise<Services>) | undefined;
}, options?: ExecutableOptions<InitArgs>) => {
    execute: <Input extends unknown, Output>(executable: Executable<InitArgs, Config, Services, Input, Output>, input?: Input | undefined) => Promise<Output>;
    prepare: <Input_1 extends unknown, Output_1>(executable: Executable<InitArgs, Config, Services, Input_1, Output_1>) => (input: Input_1) => Promise<Output_1>;
};

export { ExecutableOptions, Submodule, prepareExecutable };
